'use strict';

const moment = require('moment');

module.exports = app => {
    const { STRING, INTEGER, ENUM, DATE } = app.Sequelize;
    const HotQuestionAnswer = app.realestateModel.define('hot_question_answer', {
        id: {
            type: INTEGER,
            allowNull: false,
            primaryKey: true,
            autoIncrement: true,
        },
        user_id: {
            type: STRING,
            allowNull: true
        },
        app_user_id: {
            type: STRING,
            allowNull: true
        },
        app_id: {
            type: STRING,
            allowNull: true
        },
        app_type_id: {
            type: STRING,
            allowNull: true
        },
        question_id: {
            type: INTEGER,
            allowNull: true
        },
        answer: {
            type: STRING,
            allowNull: true
        },
        city: {
            type: INTEGER,
            allowNull: true
        },
        status: {
            type: ENUM('pass', 'refuse', 'wait'),
            allowNull: true
        },
        created_at: {
            type: DATE,
            get() {
                const date = this.getDataValue('created_at');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        },
        updated_at: {
            type: DATE,
            get() {
                const date = this.getDataValue('updated_at');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        },
        deleted_at: {
            type: DATE,
            get() {
                const date = this.getDataValue('deleted_at');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        },
    }, {
            timestamps: false,
            tableName: 'hot_question_answer',
        });

    HotQuestionAnswer.one = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        return await HotQuestionAnswer.findOne({
            attributes: attributes,
            where: where,
        });
    }


    HotQuestionAnswer.all = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const order = data.order ? data.order : [];
        return await HotQuestionAnswer.findAll({
            attributes: attributes,
            where: where,
            order,
        });
    }

    HotQuestionAnswer.list = async (data = {}) => {
        const limit = data.limit ? data.limit : 10;
        const page = data.page ? data.page : 1;
        const order = data.order ? data.order : [];
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const condition = {
            offset: (page - 1) * limit,
            limit,
            where: where,
            order: order,
            attributes: attributes,
        };
        const { count, rows } = await HotQuestionAnswer.findAndCountAll(condition);
        return { page, count, rows };
    }

    HotQuestionAnswer.add = async (data) => {
        try {
            //返回promise对象实力 instance 
            const res = await HotQuestionAnswer.create(data);
            //从promise 实例中中获得需要的id号，id 必须是自增长，而且必须主键，否则返回null
            return res.id;
        } catch (error) {
            throw (error);
        }
    }

    HotQuestionAnswer.edit = async (data) => {

        const where = data.where;
        const params = data.params;
        try {
            return await HotQuestionAnswer.update(params, { where: where })
        } catch (error) {
            throw (error);
        }
    }

    return HotQuestionAnswer;

};
